/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

import {default as React, ReactElement} from 'react';
import {MenuTriggerProps} from '@react-ui-types/menu';

export type WithDropdownClose = (close: () => void, dismiss?: () => void) => ReactElement;

export interface WithDropdownProps extends MenuTriggerProps {
  children: [ReactElement, WithDropdownClose | ReactElement],
  targetRef?: React.RefObject<HTMLElement>,
  triggerType?: 'hover' | 'click',
  isDisabled?: boolean,
  openDelay?: number,
  closeDelay?: number,
}

export interface WithDropdownTriggerAriaProps {
  isDisabled: boolean,
  overlayRef: React.RefObject<HTMLElement>,
  shouldCloseOnTriggerPress?: boolean,
  interactive?: boolean,
}
